using System;
using System.Collections.Generic;
using System.Text;

namespace ProjectLineCounter
{
    [Serializable()]
    public class ApplicationSettings
    {
        private CounterOptions _counterOptions;
        private bool _searchSubfolders;
        private FilePatternCollection _filePatterns;
        private FilePatternCollection _excludeFilePatterns;

        public ApplicationSettings()
        {
            this._counterOptions = new CounterOptions();
            this._searchSubfolders = true;
            this._filePatterns = new FilePatternCollection();
            this._excludeFilePatterns = new FilePatternCollection();
        }

        public FilePatternCollection ExcludeFilePatterns
        {
            get { return _excludeFilePatterns; }
            set { _excludeFilePatterns = value; }
        }

        public FilePatternCollection FilePatterns
        {
            get { return _filePatterns; }
            set { _filePatterns = value; }
        }

        public bool SearchSubfolders
        {
            get { return _searchSubfolders; }
            set { _searchSubfolders = value; }
        }

        public CounterOptions CounterOptions
        {
            get { return _counterOptions; }
            set { _counterOptions = value; }
        }
    }
}
