using System;
using System.Collections.Generic;
using System.Text;
using System.Windows.Forms;

namespace ProjectLineCounter
{
    internal class FileListItem : ListViewItem
    {
        private CounterResult _result;


        internal FileListItem(CounterResult result)
        {
            UpdateData(result);
        }


        internal CounterResult Result
        {
            get { return _result; }
        }

        private void UpdateData(CounterResult data)
        {
            this._result = data;

            this.Text = data.FileName;
            this.SubItems.Add(data.Lines.ToString());
            this.SubItems.Add(Convert.ToString(data.Length));

            this.ToolTipText = data.FullName;
        }
    }
}
