using System;
using System.Collections.Generic;
using System.Text;

namespace ProjectLineCounter
{
    public class FilePatternCollection : List<string>
    {
        public override string ToString()
        {
            StringBuilder result = new StringBuilder();

            foreach (string pattern in this)
            {
                result.Append(pattern + "; ");
            }

            if (result.Length > 0)
            {
                result.Remove(result.Length - 2, 2);
            }

            return result.ToString();
        }

        public static FilePatternCollection Parse(string value)
        {
            FilePatternCollection result = new FilePatternCollection();

            if (!string.IsNullOrEmpty(value))
            {
                string[] patterns = value.Split(new string[] { ";" }, StringSplitOptions.RemoveEmptyEntries);

                foreach (string pattern in patterns)
                {
                    result.Add(pattern.Trim());
                }
            }

            return result;
        }
    }
}
