using System;
using System.Collections.Generic;
using System.Text;
using System.Windows.Forms;
using System.Collections.ObjectModel;

namespace LineCounter.Application
{
    public static class ApplicationDiagnostics
    {
        private static List<Exception> _exceptions = new List<Exception>();


        public static ReadOnlyCollection<Exception> Exceptions
        {
            get { return new ReadOnlyCollection<Exception>(_exceptions); }
        }


        public static void ShowMessage(String title, String message)
        {
            MessageBox.Show(ApplicationManager.Current.MainForm, message, title, MessageBoxButtons.OK, MessageBoxIcon.Information);
        }

        public static void ShowMessageFromResource(String titleItemName, String messageItemName)
        {
            ShowMessage(Resources.Resource.GetLocalizedString(titleItemName), Resources.Resource.GetLocalizedString(messageItemName));
        }

        public static void ShowError(String title, String message)
        {
            MessageBox.Show(ApplicationManager.Current.MainForm, message, title, MessageBoxButtons.OK, MessageBoxIcon.Error);
        }

        public static void ShowErrorFromResource(String titleItemName, String messageItemName)
        {
            ShowError(Resources.Resource.GetLocalizedString(titleItemName), Resources.Resource.GetLocalizedString(messageItemName));
        }

        public static void LogException(Exception exception)
        {
            _exceptions.Add(exception);
        }

        public static void ThrowException(Exception exception)
        {
            LogException(exception);

            throw exception;
        }
    }
}
