using System;
using System.Collections.Generic;
using System.Text;

namespace LineCounter.Application
{
    /// <summary>
    /// Contains command manager event data.
    /// </summary>
    public class CommandManagerEventArgs : EventArgs
    {
        /// <summary>
        /// The command key that raised the event.
        /// </summary>
        private Command _command;

        /// <summary>
        /// Gets the command key associated with the event.
        /// </summary>
        public Command Command
        {
            get
            {
                return this._command;

            }

        }

        /// <summary>
        /// Initializes a new instance of the CommandManagerEventArgs class.
        /// </summary>
        /// <param name="commandKey">Identifier of the command that raised the event.</param>
        public CommandManagerEventArgs(Command commandItem)
        {
            this._command = commandItem;

        }

    }

}
