using System;
using System.Collections.Generic;
using System.Text;

namespace LineCounter.Application
{
    public class CounterItem
    {
        private String _name;
        private Counter _counter;
        private CounterOptionsDescriptorBase _propertyDescriptor;
        private String _id;
        private String[] _acceptableExtensions;
        private String _description;


        public CounterItem(string name, string id, Counter counter, CounterOptionsDescriptorBase propertyDescriptor, String[] acceptableExtensions)
        {
            _name = name;
            _counter = counter;
            _propertyDescriptor = propertyDescriptor;
            _id = id;
            _acceptableExtensions = acceptableExtensions;
        }

        public CounterItem(string name, string id, Counter counter, String[] acceptableExtensions)
        {
            _name = name;
            _counter = counter;
            _id = id;
            _acceptableExtensions = acceptableExtensions;
        }


        public String Name
        {
            get { return _name; }
        }

        public Counter Counter
        {
            get { return _counter; }
        }

        public CounterOptionsDescriptorBase PropertyDescriptor
        {
            get { return _propertyDescriptor; }
        }

        public String Id
        {
            get { return _id; }
        }

        public String[] GetAcceptableExtensions()
        {
            return (String[])_acceptableExtensions.Clone();
        }

        public String Description
        {
            get { return _description; }
            set { _description = value; }
        }

        public Boolean HasEditableOptions
        {
            get { return _propertyDescriptor != null; }
        }
    }
}
