using System;
using System.Collections.Generic;
using System.Text;

namespace LineCounter.Application
{
    public class FileMoveEventArgs : EventArgs
    {
        private IFileContainer _originalContainer;
        private Boolean _cancel = false;
        private IFile _file;
        private FileAction _action;


        public FileMoveEventArgs(IFileContainer originalContainer, IFile file, FileAction action)
        {
            _originalContainer = originalContainer;
            _file = file;
            _action = action;
        }


        public IFileContainer OriginalContainer
        {
            get { return _originalContainer; }
        }

        public Boolean Cancel
        {
            get { return _cancel; }
        }

        public IFile File
        {
            get { return _file; }
        }

        public FileAction Action
        {
            get { return _action; }
        }


        public String OriginalFileName
        {
            get { return FileHelper.Combine(OriginalContainer.FullName, File.Name); }
        }
    }
}
