using System;
using System.Collections.Generic;
using System.Windows.Forms;
using LineCounter.Application.UI;

namespace LineCounter.Application
{
    static class Program
    {
        /// <summary>
        /// The main entry point for the application.
        /// </summary>
        [STAThread]
        static void Main()
        {
            System.Windows.Forms.Application.SetCompatibleTextRenderingDefault(false);

            // Some counters' options pages need to be initilized before the
            // main form created, so this statement goes before the 
            // Application.SetCompatibleTextRenderingDefault().
            CounterManager.Current.LoadCounters(
                FileHelper.MapPath(ApplicationRuntimeSettings.CountersFolder));
            System.Windows.Forms.Application.EnableVisualStyles();

            ApplicationMainForm form = new ApplicationMainForm();
            FileModel.Instance.Initialize();

            ApplicationManager.Current.MainForm = form;
            ApplicationManager.Current.Initialize();

            try
            {
                System.Windows.Forms.Application.Run(form);

                //FileDetails textForm = new FileDetails();
                //textForm.ShowFile(
                //    new LineCounter.Files.LocalFile(
                //        "CodeOutlineEngline.cs",
                //        @"F:\Development\Working Projects\Code Outliner\M1\ConsoleApplication8\CodeOutlineEngline.cs",
                //        FileContentType.Countable));
                //System.Windows.Forms.Application.Run(textForm);
            }
            catch (Exception ex)
            {
                ErrorWindow errorWin = new ErrorWindow();
                errorWin.Exception = new FatalException(null, ex);
                errorWin.StartPosition = FormStartPosition.CenterScreen;
                errorWin.ShowDialog();
            }
        }
    }
}