using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using LineCounter;
using System.Diagnostics;

namespace LineCounter.Application.UI
{
    public partial class AddInAboutBox : Form
    {
        public AddInAboutBox(Type counterType)
        {
            InitializeComponent();
            
            InitilizeUI(counterType);
        }

        private void InitilizeUI(Type counterType)
        {
            string publisher = String.Empty;
            string publisherUrl = String.Empty;
            string description = String.Empty;
            string name = String.Empty;

            object[] foundCounterAtrribute = counterType.GetCustomAttributes(typeof(CounterAttribute), false);

            if (foundCounterAtrribute != null && foundCounterAtrribute.Length > 0)
            {
                CounterAttribute counterAttribute = (CounterAttribute)foundCounterAtrribute[0];

                publisher = counterAttribute.Publisher;
                publisherUrl = counterAttribute.PublisherUrl;
                name = counterAttribute.Name;
                description = counterAttribute.Description;
            }

            label_Publisher.Text = publisher;
            label_Description.Text = description;
            label_Homepage.Text = publisherUrl;
            label_Name.Text = name;
        }

        private void label_Homepage_LinkClicked(object sender, LinkLabelLinkClickedEventArgs e)
        {
            Process.Start(label_Homepage.Text);
        }
    }
}