using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using LineCounter.Application;

namespace LineCounter.Application.UI.OptionsPages
{
    public partial class General : LineCounter.Application.UI.OptionsPages.BasePage
    {
        public General()
        {
            InitializeComponent();
            LocalizeUI();
            ResetOptions();
        }

        private void LocalizeUI()
        {
            groupBox_ImportingFiles.Text = Resources.Resource.GetLocalizedString("Text_ImportingFiles");
            checkBox_ImportUnknownFiles.Text = Resources.Resource.GetLocalizedString("Text_ImportUnknownFiles");
            checkBox_ImportIgnoredFiles.Text = Resources.Resource.GetLocalizedString("Text_ImportIgnoredFiles");
        }

        public override void  ResetOptions()
        {
            checkBox_ImportIgnoredFiles.Checked = ApplicationRuntimeSettings.ImportIgnoredFiles;
            checkBox_ImportUnknownFiles.Checked = ApplicationRuntimeSettings.ImportUnknownFiles;
        }

        public override void ApplyChanges()
        {
            ApplicationRuntimeSettings.ImportIgnoredFiles = checkBox_ImportIgnoredFiles.Checked;
            ApplicationRuntimeSettings.ImportUnknownFiles = checkBox_ImportUnknownFiles.Checked;
        }
    }
}

