using System;
using System.Collections.Generic;
using System.Text;
using System.IO;
using LineCounter.Resources;
using LineCounter;

namespace LineCounter.Counters
{
    [CounterAttribute("93D733C9D2D840669367EF10F52710D4",
        "C# Counter",
        ".cs",
        AdvancedCountingSupported = false,
        Description = "C# Counter",
        HasEditableOptions = true,
        OptionsDescriptor = typeof(LineCounter.Counters.CSharpCounterOptionsDescriptor),
        Publisher = "Code Line Counter Project Team",
        PublisherUrl = @"http://www.codeplex.com/Wiki/View.aspx?ProjectName=LineCounter")]
    public class CSharpCounter : Counter
    {
        private enum BlockType
        {
            Region,
            Using,
            Method,
            TypeDefination,
            Document
        }


        private const String nameSpaceElementName = "namespace";
        private const String regionElementName = "region";
        private const String classElementName = "class";
        private const String methodElementName = "method";
        private const String propertyElementName = "property";
        private const String stringElementName = "string";
        private const String commonElementName = "commonElement";

        //private class CSharpCodeFormat : FileFormat
        //{
        //    public CSharpCodeFormat()
        //        : base()
        //    {
        //        InitializeIdentities();
        //    }


        //    private void InitializeIdentities()
        //    {
        //        String userDefinedKeyword = Keywords.CStyleCodeUserDefinedKeywordKeyword.Keyword;
        //        String returnTypeName = Keywords.CStyleCodeTypeNameKeyword.Keyword;

        //        FileElementIdentity classIdentity = new FileElementIdentity();
        //        classIdentity.ElementBlockClosedSymbol = Keywords.CStyleCodeElementCodeBlockClosedSymbol;
        //        classIdentity.ElementBlockOpenSymbol = Keywords.CStyleCodeElementCodeBlockOpenSymbol;
        //        classIdentity.ElementTypeName = "Class";
        //        classIdentity.CanBeRootElement = true;
        //        classIdentity.CanHaveSubItems = true;
        //        classIdentity.ContentType = FileElementContentType.MutipleLineMetaData;
        //        classIdentity.HeaderKeyword = new SearchKeyword(@"(?<modifier>((internal|protected internal|public|protected|private|abstract|virtual|static)[ \t]+){0,3})class[ \t]+(?<blockname>" + userDefinedKeyword + @")[ \t]*(:[ \t]*" + userDefinedKeyword + ")?", FindMethod.RegularExpression);
        //        classIdentity.HeaderKeyword.ResultGroupNames.Add("modifier", "Modifier");
        //        classIdentity.HeaderKeyword.ResultGroupNames.Add("blockname", "BlockName");
        //        classIdentity.ElementNamePosition = FileElementNamePosition.Header;
        //        classIdentity.ElementNameKeyword = "blockname";
        //        classIdentity.LegalContainerIdentityNames.Add(nameSpaceElementName);
        //        classIdentity.LegalContainerIdentityNames.Add(classElementName);
        //        classIdentity.LegalContainerIdentityNames.Add(regionElementName);
        //        classIdentity.Name = classElementName;
        //        classIdentity.HeaderPosition = FileElementHeaderPosition.InFrontOfBlock;

        //        FileElementIdentity methodIdentity = new FileElementIdentity();
        //        methodIdentity.ElementBlockClosedSymbol = Keywords.CStyleCodeElementCodeBlockClosedSymbol;
        //        methodIdentity.ElementBlockOpenSymbol = Keywords.CStyleCodeElementCodeBlockOpenSymbol;
        //        methodIdentity.ElementTypeName = "Method";
        //        methodIdentity.CanBeRootElement = false;
        //        methodIdentity.CanHaveSubItems = true;
        //        methodIdentity.ContentType = FileElementContentType.MutipleLineMetaData;
        //        methodIdentity.HeaderKeyword = new SearchKeyword(@"(?<modifier>((internal|protected internal|public|protected|private|abstract|virtual|override|static)[ \t]+){0,3})(?<returntype>" + returnTypeName + @")[ \t]+(?<blockname>" + userDefinedKeyword + @")[ \t]*\((?<parameters>[ \t]*(((ref|out)[ \t]+)?" + returnTypeName + "[ \t]+" + userDefinedKeyword + "[ \t]*,[ \t]*)*(((ref|out|params)[ \t]+)?" + returnTypeName + "[ \t]+" + userDefinedKeyword + @"){0,1}[ \t]*)\);?", FindMethod.RegularExpression);
        //        methodIdentity.HeaderKeyword.ResultGroupNames.Add("modifier", "Modifier");
        //        methodIdentity.HeaderKeyword.ResultGroupNames.Add("blockname", "BlockName");
        //        methodIdentity.HeaderKeyword.ResultGroupNames.Add("returnType", "ReturnType");
        //        methodIdentity.HeaderKeyword.ResultGroupNames.Add("parameters", "Parameters");
        //        methodIdentity.ElementNameKeyword = "blockname";
        //        methodIdentity.ElementNamePosition = FileElementNamePosition.Header;
        //        methodIdentity.LegalContainerIdentityNames.Add(classElementName);
        //        methodIdentity.LegalContainerIdentityNames.Add(regionElementName);
        //        methodIdentity.Name = methodElementName;
        //        methodIdentity.HeaderPosition = FileElementHeaderPosition.InFrontOfBlock;

        //        FileElementIdentity propertyIdentity = new FileElementIdentity();
        //        propertyIdentity.ElementBlockClosedSymbol = Keywords.CStyleCodeElementCodeBlockClosedSymbol;
        //        propertyIdentity.ElementBlockOpenSymbol = Keywords.CStyleCodeElementCodeBlockOpenSymbol;
        //        propertyIdentity.ElementTypeName = "Property";
        //        propertyIdentity.CanBeRootElement = false;
        //        propertyIdentity.CanHaveSubItems = true;
        //        propertyIdentity.ContentType = FileElementContentType.MutipleLineMetaData;
        //        propertyIdentity.HeaderKeyword = new SearchKeyword(@"(?<modifier>((internal|protected internal|public|protected|private|abstract|virtual|override)[ \t]+){0,2})(?<returntype>" + userDefinedKeyword + ")[ \t]+(?<blockname>" + userDefinedKeyword + ")[ \t]*(?=({|$))", FindMethod.RegularExpression);
        //        propertyIdentity.HeaderKeyword.ResultGroupNames.Add("modifier", "Modifier");
        //        propertyIdentity.HeaderKeyword.ResultGroupNames.Add("blockname", "BlockName");
        //        propertyIdentity.HeaderKeyword.ResultGroupNames.Add("returnType", "ReturnType");
        //        propertyIdentity.ElementNameKeyword = "blockname";
        //        propertyIdentity.ElementNamePosition = FileElementNamePosition.Header;
        //        propertyIdentity.LegalContainerIdentityNames.Add(classElementName);
        //        propertyIdentity.LegalContainerIdentityNames.Add(regionElementName);
        //        propertyIdentity.Name = propertyElementName;
        //        propertyIdentity.HeaderPosition = FileElementHeaderPosition.InFrontOfBlock;

        //        FileElementIdentity commonElementIdentity = new FileElementIdentity();
        //        commonElementIdentity.ElementBlockClosedSymbol = Keywords.CStyleCodeElementCodeBlockClosedSymbol;
        //        commonElementIdentity.ElementBlockOpenSymbol = Keywords.CStyleCodeElementCodeBlockOpenSymbol;
        //        commonElementIdentity.ElementTypeName = "CommonElement";
        //        commonElementIdentity.CanBeRootElement = false;
        //        commonElementIdentity.CanHaveSubItems = true;
        //        commonElementIdentity.ContentType = FileElementContentType.MutipleLineMetaData;
        //        commonElementIdentity.LegalContainerIdentityNames.Add(classElementName);
        //        commonElementIdentity.LegalContainerIdentityNames.Add(methodElementName);
        //        commonElementIdentity.LegalContainerIdentityNames.Add(propertyElementName);
        //        commonElementIdentity.LegalContainerIdentityNames.Add(commonElementName);
        //        commonElementIdentity.LegalContainerIdentityNames.Add(regionElementName);
        //        commonElementIdentity.Name = commonElementName;
        //        commonElementIdentity.ElementNamePosition = FileElementNamePosition.None;
        //        commonElementIdentity.HeaderPosition = FileElementHeaderPosition.None;
        //        commonElementIdentity.AppendToOutline = false;

        //        FileElementIdentity commentBlockIdentity = new FileElementIdentity();
        //        commentBlockIdentity.ElementBlockClosedSymbol = Keywords.CStyleCodeElementMutipleLineCommentBlockClosedSymbol;
        //        commentBlockIdentity.ElementBlockOpenSymbol = Keywords.CStyleCodeElementMutipleLineCommentBlockOpenSymbol;
        //        commentBlockIdentity.ElementTypeName = "CommentBlock";
        //        commentBlockIdentity.CanBeRootElement = true;
        //        commentBlockIdentity.CanHaveSubItems = false;
        //        commentBlockIdentity.ContentType = FileElementContentType.MutipleLineStringLiteral;
        //        commentBlockIdentity.LegalContainerIdentityNames.Add(classElementName);
        //        commentBlockIdentity.LegalContainerIdentityNames.Add(methodElementName);
        //        commentBlockIdentity.LegalContainerIdentityNames.Add(propertyElementName);
        //        commentBlockIdentity.LegalContainerIdentityNames.Add(regionElementName);
        //        commentBlockIdentity.Name = "commentBlock";
        //        commentBlockIdentity.ElementNamePosition = FileElementNamePosition.None;
        //        commentBlockIdentity.HeaderPosition = FileElementHeaderPosition.None;

        //        FileElementIdentity stringIdentity = new FileElementIdentity();
        //        stringIdentity.ElementBlockClosedSymbol = Keywords.CStyleCodeElementStringBlockClosedSymbol;
        //        stringIdentity.ElementBlockOpenSymbol = Keywords.CStyleCodeElementStringBlockOpenSymbol;
        //        stringIdentity.ElementTypeName = "String";
        //        stringIdentity.CanBeRootElement = false;
        //        stringIdentity.CanHaveSubItems = false;
        //        stringIdentity.ContentType = FileElementContentType.MutipleLineStringLiteral;
        //        stringIdentity.LegalContainerIdentityNames.Add(classElementName);
        //        stringIdentity.LegalContainerIdentityNames.Add(methodElementName);
        //        stringIdentity.LegalContainerIdentityNames.Add(regionElementName);
        //        stringIdentity.Name = stringElementName;
        //        stringIdentity.ElementNamePosition = FileElementNamePosition.None;
        //        stringIdentity.HeaderPosition = FileElementHeaderPosition.None;
        //        stringIdentity.AppendToOutline = false;

        //        FileElementIdentity mutipleLineCommentIdentity = new FileElementIdentity();
        //        mutipleLineCommentIdentity.ElementBlockClosedSymbol = Keywords.CStyleCodeElementMutipleLineCommentBlockClosedSymbol;
        //        mutipleLineCommentIdentity.ElementBlockOpenSymbol = Keywords.CStyleCodeElementMutipleLineCommentBlockOpenSymbol;
        //        mutipleLineCommentIdentity.ElementTypeName = "MutipleLineComment";
        //        mutipleLineCommentIdentity.CanBeRootElement = true;
        //        mutipleLineCommentIdentity.CanHaveSubItems = false;
        //        mutipleLineCommentIdentity.ContentType = FileElementContentType.MutipleLineStringLiteral;
        //        mutipleLineCommentIdentity.HeaderPosition = FileElementHeaderPosition.None;
        //        mutipleLineCommentIdentity.LegalContainerIdentityNames.Add(regionElementName);
        //        mutipleLineCommentIdentity.ElementNamePosition = FileElementNamePosition.None;
        //        mutipleLineCommentIdentity.Name = "mutipleLineComment";

        //        FileElementIdentity regionBlockIdentity = new FileElementIdentity();
        //        regionBlockIdentity.CanBeRootElement = true;
        //        regionBlockIdentity.CanHaveSubItems = true;
        //        regionBlockIdentity.ContentType = FileElementContentType.MutipleLineMetaData;
        //        regionBlockIdentity.ElementBlockClosedSymbol = new SearchKeyword("(?<=(^[ \t]*))#endregion", FindMethod.RegularExpression);
        //        regionBlockIdentity.ElementBlockOpenSymbol = new SearchKeyword("$", FindMethod.RegularExpression);
        //        regionBlockIdentity.HeaderKeyword = new SearchKeyword("(?<=(^[ \t]*))#region (?<blockname>(.+))", FindMethod.RegularExpression);
        //        regionBlockIdentity.HeaderKeyword.ResultGroupNames.Add("blockname", "BlockName");
        //        regionBlockIdentity.ElementNameKeyword = "blockname";
        //        regionBlockIdentity.ElementNamePosition = FileElementNamePosition.Header;
        //        regionBlockIdentity.ElementTypeName = regionElementName;
        //        regionBlockIdentity.HeaderPosition = FileElementHeaderPosition.InFrontOfBlock;
        //        regionBlockIdentity.LegalContainerIdentityNames.Add(classElementName);
        //        regionBlockIdentity.LegalContainerIdentityNames.Add(propertyElementName);
        //        regionBlockIdentity.LegalContainerIdentityNames.Add(methodElementName);
        //        regionBlockIdentity.LegalContainerIdentityNames.Add("commonBlock");
        //        regionBlockIdentity.Name = regionElementName;

        //        this.Identities.Add(regionBlockIdentity.Name, regionBlockIdentity);
        //        this.Identities.Add(classIdentity.Name, classIdentity);
        //        this.Identities.Add(methodIdentity.Name, methodIdentity);
        //        this.Identities.Add(propertyIdentity.Name, propertyIdentity);
        //        this.Identities.Add(stringIdentity.Name, stringIdentity);
        //        this.Identities.Add(commonElementIdentity.Name, commonElementIdentity);
        //        this.Identities.Add(commentBlockIdentity.Name, commentBlockIdentity);
        //        this.Identities.Add(mutipleLineCommentIdentity.Name, mutipleLineCommentIdentity);

        //        this.BuildIdentitySummary();
        //    }
        //}


        private CSharpCounterOptions _options;


        public CSharpCounter()
            : base(Roy.Text.Outline.OutlineEngineFactory.CSharp)
        {
        }


        public override CounterOptions Options
        {
            get { return _options; }
            set
            {
                if (value == null)
                {
                    _options = null;
                    return;
                }

                CSharpCounterOptions typedValue = value as CSharpCounterOptions;

                if (typedValue != null)
                {
                    _options = typedValue;
                }
                else
                {
                    throw new ArgumentException(Resources.Resource.GetLocalizedString("Message_WrongOptionsType", "CSharpCounterOptions"));
                }
            }
        }

        private CSharpCounterOptions TypedOptions
        {
            get { return (CSharpCounterOptions)Options; }
        }


        protected override Int32 GetLinesWithFilter(StreamReader reader, out Int32 ignoredLines)
        {
            int lines = 0;
            ignoredLines = 0;

            try
            {
                while (!reader.EndOfStream)
                {
                    string line = reader.ReadLine().Trim();

                    if (line.IndexOf("using ") != -1 
                        && line.IndexOf(";") != -1 
                        && line.IndexOf("{") == -1
                        && !this.TypedOptions.IncludeUsingBlocks)
                    {
                        line = GoToEndOfBlock(reader, BlockType.Using);
                    }
                    if (line.IndexOf(@"//") == 0
                        && !this.TypedOptions.IncludeComment)
                    {
                        ignoredLines++;
                    }
                    else if (line.IndexOf("#region") != -1
                    && this.TypedOptions.SpecialRegions.Contains(GetRegionName(line)))
                    {
                        line = GoToEndOfBlock(reader, BlockType.Region);
                    }
                    else if (line == "" && !this.TypedOptions.IncludeBlanks)
                    {
                        ignoredLines++;
                    }
                    else if ((line == "{" || line == "}") && !this.TypedOptions.IncludeBracket)
                    {
                        ignoredLines++;
                    }
                    else
                    {
                        lines++;
                    }
                }
            }
            catch { }
            finally
            {
                if (reader != null)
                {
                    reader.Close();
                    reader.Dispose();
                }
            }

            return lines;
        }

        private static string GetRegionName(string line)
        {
            string result = line.Trim().Replace("#region ", string.Empty);

            return result;
        }

        private static string GoToEndOfBlock(StreamReader reader, BlockType type)
        {
            string line;
            bool toContinue = true;
            string firstLine = null;

            switch (type)
            {
                case BlockType.Document:
                    {
                        while (toContinue && !reader.EndOfStream)
                        {
                            line = GetNextLine(reader);
                            if (line.TrimStart(' ').IndexOf("///") != 0)
                            {
                                toContinue = false;
                                firstLine = line;
                            }
                        }
                        break;
                    }
                case BlockType.Method:
                    {
                        break;
                    }
                case BlockType.Region:
                    {
                        int regions = 1;
                        line = GetNextLine(reader);

                        while (regions > 0 && !reader.EndOfStream)
                        {
                            line = GetNextLine(reader);
                            if (line.IndexOf("#endregion") == 0)
                            {
                                regions--;
                            }
                            else if (line.IndexOf("#region") == 0)
                            {
                                regions++;
                            }
                        }

                        firstLine = GetNextLine(reader);

                        break;
                    }
                case BlockType.TypeDefination:
                    {
                        break;
                    }
                case BlockType.Using:
                    {
                        while (toContinue && !reader.EndOfStream)
                        {
                            line = GetNextLine(reader);

                            if (line.Trim().IndexOf("using ") == -1)
                            {
                                toContinue = false;
                                firstLine = line;
                            }
                        }
                        break;
                    }
            }

            return firstLine;
        }

        private static string GetNextLine(StreamReader reader)
        {
            string line;

            if (reader.EndOfStream)
            {
                line = null;
            }
            else
            {
                line = reader.ReadLine().Trim();
            }

            return line;
        }


        protected override Int32 GetLinesFromOutline(Roy.Text.Outline.CodeOutline outline, out Int32 ignoredLines)
        {
            //Int32 currentLineNumber = 0;
            //Int32 lines = 0;

            //foreach (FileElement element in outline.Elements)
            //{
            //    if (element.StartPosition.LineNumber == element.EndPosition.LineNumber
            //        && element.EndPosition.Index - element.StartPosition.Index > 1)
            //    {
            //        lines += 1;
            //    }
            //    else
            //    {
            //        lines += element.EndPosition.LineNumber - element.StartPosition.LineNumber - 1;
            //    }
            //}

            //return lines;

            ignoredLines = 0;
            return outline.Root.Lines;
        }
    }
}
