using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace LineCounter.Counters
{
    public partial class CSharpCounterGeneralPage : LineCounter.Application.UI.OptionsPages.CounterOptionsPageBase
    {
        private CSharpCounterOptions _options;


        public CSharpCounterGeneralPage(CSharpCounterOptions options)
        {
            _options = options;

            InitializeComponent();

            LocalizeUI();

            ResetOptions();
        }

        private void LocalizeUI()
        {
            groupBox_Omits.Text = Resources.Resource.GetLocalizedString("Text_Omits");
            label_Omits.Text = Resources.Resource.GetLocalizedString("Text_CounterOmitSetting_Description");
            checkBox_UsingBlocks.Text = Resources.Resource.GetLocalizedString("Text_HotKey_UsingBlocks");
            checkBox_LinesBracketOnly.Text = Resources.Resource.GetLocalizedString("Text_HotKey_BracketOnly");
            checkBox_CommentLines.Text = Resources.Resource.GetLocalizedString("Text_HotKey_CommentLines");
            checkBox_BlankLines.Text = Resources.Resource.GetLocalizedString("Text_HotKey_BlankLines");
        }


        public CSharpCounterOptions Options
        {
            get { return _options; }
            set { _options = value; }
        }


        public override void ResetOptions()
        {
            if (_options != null)
            {
                checkBox_BlankLines.Checked = !_options.IncludeBlanks;
                checkBox_CommentLines.Checked = !_options.IncludeComment;
                checkBox_LinesBracketOnly.Checked = !_options.IncludeBracket;
                checkBox_UsingBlocks.Checked = !_options.IncludeUsingBlocks;
            }
        }

        public override void ApplyChanges()
        {
            if (_options != null)
            {
                _options.IncludeBlanks = !checkBox_BlankLines.Checked;
                _options.IncludeComment = !checkBox_CommentLines.Checked;
                _options.IncludeBracket = !checkBox_LinesBracketOnly.Checked;
                _options.IncludeUsingBlocks = !checkBox_UsingBlocks.Checked;
            }
        }
    }
}

