﻿using System;
using System.Collections.Generic;
using System.Text;

namespace LineCounter.Counters
{
    [CounterAttribute("93D733C9D2D840669367EF10F52710D5",
    "General Counter",
    ".js", ".java", ".c", ".php", ".txt", ".vbs", ".ini", ".log", ".*",
    AdvancedCountingSupported = false,
    Description = "General Counter",
    HasEditableOptions = true,
    OptionsDescriptor = typeof(LineCounter.Counters.GeneralCounterOptionsDescriptor),
    Publisher = "Code Line Counter Project Team",
    PublisherUrl = @"http://linecounter.codeplex.com")]
    public class GeneralCounter : Counter
    {
        private GeneralCounterOptions _options;



        public override CounterOptions Options
        {
            get
            {
                return _options;
            }
            set
            {
                if (value == null)
                {
                    _options = null;
                    return;
                }

                GeneralCounterOptions typedValue = value as GeneralCounterOptions;

                if (typedValue != null)
                {
                    _options = typedValue;
                }
                else
                {
                    throw new ArgumentException(Resources.Resource.GetLocalizedString("Message_WrongOptionsType", "CSharpCounterOptions"));
                }
            }
        }

        protected override int GetLinesWithFilter(System.IO.StreamReader reader, out int ignoredLines)
        {
            string line;
            int result = 0;
            ignoredLines = 0;
            GeneralCounterOptions options = this.Options as GeneralCounterOptions;

            if (options == null)
            {
                while (!reader.EndOfStream)
                {
                    line = reader.ReadLine();
                    result++;
                }
            }
            else
            {
                while (!reader.EndOfStream)
                {
                    line = reader.ReadLine();
                    if (options.IncludeBlanks
                        || line.Trim().Length > 0)
                    {
                        result++;
                    }
                    else
                    {
                        ignoredLines++;
                    }
                }
            }

            return result;
        }

        protected override int GetLinesFromOutline(Roy.Text.Outline.CodeOutline outline, out int ignoredLines)
        {
            throw new NotImplementedException();
        }
    }
}
