﻿using System;
using System.Collections.Generic;
using System.Text;

namespace LineCounter.Counters
{
    public sealed class GeneralCounterOptionsDescriptor : CounterOptionsDescriptorBase, IDisposable
    {        
        private const String GeneralPageTag = "Genreal ";
        private GeneralCounterOptionsPage _generalPage;
        private GeneralCounterOptions options;


        public GeneralCounterOptionsDescriptor()
        {
            options = new GeneralCounterOptions(LineCounter.Counters.Properties.Settings.Default);
        }


        private GeneralCounterOptionsPage GeneralPage
        {
            get
            {
                if (_generalPage == null)
                {
                    _generalPage = new GeneralCounterOptionsPage(options);
                }

                return _generalPage;
            }
        }


        public override CounterOptions GetOptions()
        {
            return options;
        }

        public override LineCounter.Application.UI.OptionsPages.CounterOptionsPageBase GetOptionsPage(string name)
        {
            switch (name)
            {
                case GeneralPageTag:
                    {
                        return GeneralPage;
                    }
                default:
                    {
                        return null;
                    }
            }
        }

        public override String[] GetOptionsPagesNames()
        {
            return new String[] { GeneralPageTag };
        }

        public override void SaveOptions()
        {
            LineCounter.Counters.Properties.Settings.Default.Save();
        }

        public override void ResetOptions()
        {
            LineCounter.Counters.Properties.Settings.Default.Reset();
        }

        #region IDisposable Members

        public void Dispose()
        {
            if (_generalPage != null)
            {
                _generalPage.Dispose();
            }
        }

        #endregion
    }
}
