﻿using System;
using System.Collections.Generic;
using System.Text;

namespace LineCounter.Counters
{
    public class GeneralCounterOptionsPage : LineCounter.Application.UI.OptionsPages.CounterOptionsPageBase
    {
        private GeneralCounterOptions _options;
        private System.Windows.Forms.GroupBox groupBox_Omits;
        private System.Windows.Forms.CheckBox checkBox_BlankLines;
        private System.Windows.Forms.Label label_Omits;


        public GeneralCounterOptionsPage(GeneralCounterOptions options)
        {
            _options = options;

            InitializeComponent();
            LocalizeUI();
            ResetOptions();
        }


        private void InitializeComponent()
        {
            this.groupBox_Omits = new System.Windows.Forms.GroupBox();
            this.checkBox_BlankLines = new System.Windows.Forms.CheckBox();
            this.label_Omits = new System.Windows.Forms.Label();
            this.groupBox_Omits.SuspendLayout();
            this.SuspendLayout();
            // 
            // groupBox_Omits
            // 
            this.groupBox_Omits.Controls.Add(this.checkBox_BlankLines);
            this.groupBox_Omits.Controls.Add(this.label_Omits);
            this.groupBox_Omits.Location = new System.Drawing.Point(3, 3);
            this.groupBox_Omits.Name = "groupBox_Omits";
            this.groupBox_Omits.Size = new System.Drawing.Size(334, 150);
            this.groupBox_Omits.TabIndex = 1;
            this.groupBox_Omits.TabStop = false;
            this.groupBox_Omits.Text = "Ignores";
            // 
            // checkBox_BlankLines
            // 
            this.checkBox_BlankLines.AutoSize = true;
            this.checkBox_BlankLines.Location = new System.Drawing.Point(9, 52);
            this.checkBox_BlankLines.Name = "checkBox_BlankLines";
            this.checkBox_BlankLines.Size = new System.Drawing.Size(109, 17);
            this.checkBox_BlankLines.TabIndex = 4;
            this.checkBox_BlankLines.Text = "Ignore blank lines";
            this.checkBox_BlankLines.UseVisualStyleBackColor = true;
            // 
            // label_Omits
            // 
            this.label_Omits.Location = new System.Drawing.Point(6, 16);
            this.label_Omits.Name = "label_Omits";
            this.label_Omits.Size = new System.Drawing.Size(322, 33);
            this.label_Omits.TabIndex = 0;
            // 
            // GeneralCounterOptionsPage
            // 
            this.AutoScaleDimensions = new System.Drawing.SizeF(6F, 13F);
            this.Controls.Add(this.groupBox_Omits);
            this.Name = "GeneralCounterOptionsPage";
            this.groupBox_Omits.ResumeLayout(false);
            this.groupBox_Omits.PerformLayout();
            this.ResumeLayout(false);

        }

        private void LocalizeUI()
        {
            groupBox_Omits.Text = Resources.Resource.GetLocalizedString("Text_Omits");
            label_Omits.Text = Resources.Resource.GetLocalizedString("Text_CounterOmitSetting_Description");
            checkBox_BlankLines.Text = Resources.Resource.GetLocalizedString("Text_HotKey_BlankLines");
        }

        public override void ResetOptions()
        {
            if (_options != null)
            {
                checkBox_BlankLines.Checked = _options.IncludeBlanks;
            }
        }


        public override void ApplyChanges()
        {
            if (_options != null)
            {
                _options.IncludeBlanks = checkBox_BlankLines.Checked;
            }
        }

    }
}
