using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Text;
using System.Windows.Forms;

namespace LineCounter.Application.UI.OptionsPages
{
    /// <summary>
    /// Respresents a page in options form.
    /// </summary>
    public partial class BasePage : UserControl, INamedObject
    {
        private String _displayName;


        public BasePage()
        {
            InitializeComponent();
        }

        #region INamedObject Members


        public String DisplayName
        {
            get
            {
                return _displayName;
            }
            set
            {
                _displayName = value;
            }
        }

        public new String Name
        {
            get
            {
                return base.Name;
            }
            set
            {
                base.Name = value;
            }
        }

        #endregion


        public virtual void ResetOptions() { }
        public virtual void CancelChanges() 
        {
            ResetOptions();
        }
        public virtual void ApplyChanges() { }
    }
}
