using System;
using System.Collections.Generic;
using System.Text;
using System.Windows.Forms;

namespace LineCounter.Application.UI.OptionsPages
{
    [Serializable]
    public class OptionsPageDictionary : Dictionary<String, BasePage>
    {
        /// <summary>
        /// Add a page to collection.
        /// </summary>
        /// <exception cref="ArgumentNullException" />
        public void Add(BasePage page)
        {
            if (page == null)
            {
                throw new ArgumentNullException("page");
            }

            this.Add(page.Name, page);
        }
    }
}
