using System;
using System.Collections.Generic;
using System.Text;
using System.Collections.ObjectModel;

namespace LineCounter
{
    public class FileElementCollection : List<FileElement>
    {
        private FileElement _container;


        public FileElementCollection()
            : this(null) { }

        public FileElementCollection(FileElement container)
        {
            _container = container;
        }


        public FileElement Container
        {
            get { return _container; }
        }


        public new void Add(FileElement item)
        {
            base.Add(item);

            if (item.Container != null)
            {
                item.Container = Container;
            }
        }

        public new void Remove(FileElement item)
        {
            base.Remove(item);
            item.Container = null;
        }

        public new void RemoveAt(int index)
        {
            this[index].Container = null;
            base.RemoveAt(index);
        }
    }

    public class ReadOnlyFileElementCollection : ReadOnlyCollection<FileElement>
    {
        public ReadOnlyFileElementCollection(FileElementCollection collection)
            :base(collection)
        {
        }
    }
}
