using System;
using System.Collections.Generic;
using System.Text;

namespace LineCounter
{
    public class FileElementHeader
    {
        private FileElement _element;
        private FilePosition _startPosition;
        private Int32 _count;
        private System.Collections.Specialized.StringDictionary _keywords;


        public FileElementHeader() : this(null) { }

        public FileElementHeader(FileElement element)
        {
            _keywords = new System.Collections.Specialized.StringDictionary();
            _element = element;
            _startPosition = new FilePosition(-1, 0);
        }


        /// <summary>
        /// Gets the element the header belongs to.
        /// </summary>
        public FileElement Element
        {
            get { return _element; }
            set { _element = value; }
        }

        /// <summary>
        /// Gets or sets header start position.
        /// </summary>
        public FilePosition StartPosition
        {
            get { return _startPosition; }
            set { _startPosition = value; }
        }

        /// <summary>
        /// Gets or sets the length of the header text
        /// </summary>
        public Int32 Count
        {
            get { return _count; }
            set { _count = value; }
        }

        public System.Collections.Specialized.StringDictionary Keywords
        {
            get { return _keywords; }
        }
    }
}
