using System;
using System.Collections.Generic;
using System.Text;

namespace LineCounter
{
    public enum FileElementContentType
    {
        None = 0,
        SingleLineMetaData,
        MutipleLineMetaData,
        SingleLineStringLiteral,
        MutipleLineStringLiteral
    }

    public enum FileElementHeaderPosition
    {
        None = 0,
        InFrontOfBlock
    }

    public enum FileElementNamePosition
    {
        None = 0,
        Header,
        BlockStartSymbol,
        BlockCloseSymbol
    }

    public class FileElementIdentity
    {
        public const String RootName = "$Root$";
        private String _name;
        private String _elementTypeName;
        private SearchKeyword _elementBlockOpenSymbol;
        private SearchKeyword _elementBlockClosedSymbol;
        private SearchKeyword _headerKeyword;
        private FileElementContentType _contentType;
        private Boolean _canHaveSubItems;
        private Boolean _canBeRootElement;
        private System.Collections.Specialized.StringCollection _legalContainerIdentityNames;
        private FileElementHeaderPosition _headerPosition;
        private String _elementNameKeyword;
        private Boolean _appendToOutline = true;
        private FileElementNamePosition _elementNamePosition;


        public FileElementIdentity()
        {
            _legalContainerIdentityNames = new System.Collections.Specialized.StringCollection();
        }


        public String Name
        {
            get { return _name; }
            set { _name = value; }
        }

        public String ElementTypeName
        {
            get { return _elementTypeName; }
            set { _elementTypeName = value; }
        }

        public SearchKeyword ElementBlockOpenSymbol
        {
            get { return _elementBlockOpenSymbol; }
            set { _elementBlockOpenSymbol = value; }
        }

        public SearchKeyword ElementBlockClosedSymbol
        {
            get { return _elementBlockClosedSymbol; }
            set { _elementBlockClosedSymbol = value; }
        }

        public SearchKeyword HeaderKeyword
        {
            get { return _headerKeyword; }
            set { _headerKeyword = value; }
        }

        public FileElementContentType ContentType
        {
            get { return _contentType; }
            set { _contentType = value; }
        }

        public Boolean CanHaveSubItems
        {
            get { return _canHaveSubItems; }
            set { _canHaveSubItems = value; }
        }

        public Boolean CanBeRootElement
        {
            get { return _canBeRootElement; }
            set { _canBeRootElement = value; }
        }

        public System.Collections.Specialized.StringCollection LegalContainerIdentityNames
        {
            get { return _legalContainerIdentityNames; }
            set { _legalContainerIdentityNames = value; }
        }

        public FileElementHeaderPosition HeaderPosition
        {
            get { return _headerPosition; }
            set { _headerPosition = value; }
        }

        public String ElementNameKeyword
        {
            get { return _elementNameKeyword; }
            set { _elementNameKeyword = value; }
        }

        public Boolean AppendToOutline
        {
            get { return _appendToOutline; }
            set { _appendToOutline = value; }
        }

        public FileElementNamePosition ElementNamePosition
        {
            get { return _elementNamePosition; }
            set { _elementNamePosition = value; }
        }
    }
}
