using System;
using System.Collections.Generic;
using System.Text;

namespace LineCounter
{
    public interface IFileContainer : IFile
    {
        FileDictionary Files { get; }
        FileContainerDictionary SubContainers { get; }
        FileContainerType ContainerType { get;}


        IEnumerable<IFile> GetFilesByType(FileContentType type, Boolean topContainerOnly);
        void AddFile(IFile file);
        void AddFileContainer(IFileContainer container);
        void RemoveFile(IFile file);
        void RemoveFileContainer(IFileContainer container);
        bool Contains(IFile file);
        bool Contains(IFileContainer container);
    }
}
