using System;
using System.Collections.Generic;
using System.Text;
using System.Runtime.Serialization;

namespace LineCounter
{
    public class InternalFileException : Exception
    {
        private String _fileName;
        private String _fileDisplayName;


        public InternalFileException(String fileName, String fileDisplayName)
            : this(fileName, fileDisplayName, null) { }

        public InternalFileException(String fileName, String fileDisplayName, String message)
            : base(message)
        {
            _fileName = fileName;
            _fileDisplayName = fileDisplayName;
        }


        public String FileName
        {
            get { return _fileName; }
        }

        public String FileDisplayName
        {
            get { return _fileDisplayName; }
        }
    }
}
