using System;
using System.Collections.Generic;
using System.Text;

namespace LineCounter
{
    public sealed class Keywords
    {
        private static String cStyleCodeUserDefinedKeywordRegex = "[_a-zA-Z][0-9a-zA-Z_]*";

        public static SearchKeyword CStyleCodeElementCodeBlockOpenSymbol
        {
            get
            {
                return new SearchKeyword("((?<=(((?<!(//.*|\\\\))\".*){2})+){)|((?<!(?<!(//.*|\\\\))\".*){)", FindMethod.RegularExpression);
            }
        }

        public static SearchKeyword CStyleCodeElementCodeBlockClosedSymbol
        {
            get
            {
                return new SearchKeyword("((?<=(((?<!(//.*|\\\\))\".*){2})+)})|((?<!(?<!(//.*|\\\\))\".*)})", FindMethod.RegularExpression);
            }
        }

        public static SearchKeyword CStyleCodeElementStringBlockOpenSymbol
        {
            get
            {
                return new SearchKeyword("(?<!(//.*|\\\\))@?\"", FindMethod.RegularExpression);
            }
        }

        public static SearchKeyword CStyleCodeElementStringBlockClosedSymbol
        {
            get
            {
                return new SearchKeyword("(?<!(//.*|\\\\))\"", FindMethod.RegularExpression);
            }
        }

        public static SearchKeyword CStyleCodeElementMutipleLineCommentBlockOpenSymbol
        {
            get
            {
                return new SearchKeyword(@"(?<!(\\))\\\*", FindMethod.RegularExpression);
            }
        }

        public static SearchKeyword CStyleCodeElementMutipleLineCommentBlockClosedSymbol
        {
            get
            {
                return new SearchKeyword(@"(?<!(\\))\*\\", FindMethod.RegularExpression);
            }
        }

        public static SearchKeyword CStyleCodeElementSingleLineStringKeyword
        {
            get
            {
                return new SearchKeyword("(?=(?<!(//.*|\\\\))@?\")", FindMethod.RegularExpression);
            }
        }

        public static SearchKeyword CStyleCodeUserDefinedKeywordKeyword
        {
            get { return new SearchKeyword(cStyleCodeUserDefinedKeywordRegex, FindMethod.RegularExpression); }
            //get { return new RegexSearchKeyword("[^ \t{}(),:\\\\;\"]+"); }
        }

        public static SearchKeyword CStyleCodeTypeNameKeyword
        {
            get { return new SearchKeyword(@"[*]?[_a-zA-Z][0-9a-zA-Z_.]*(<[*]?[_a-zA-Z][0-9a-zA-Z_.]*>)?(\[\])?[*]?", FindMethod.RegularExpression); }
        }
    }
}
    