using System;
using System.Collections.Generic;
using System.Text;

namespace LineCounter
{
    public enum FindMethod
    {
        Normal,
        RegularExpression
    }

    public class SearchKeyword
    {
        private String _keyword;
        private FindMethod _findMethod;
        private System.Collections.Specialized.StringDictionary _resultGroupNames;


        public SearchKeyword(String keyword, FindMethod findMethod)
        {
            _keyword = keyword;
            _findMethod = findMethod;
        }


        /// <summary>
        /// Gets the group names 
        /// </summary>
        public System.Collections.Specialized.StringDictionary ResultGroupNames
        {
            get
            {
                if (_resultGroupNames == null)
                {
                    _resultGroupNames = new System.Collections.Specialized.StringDictionary();
                }

                return _resultGroupNames; 
            }
        }


        public String Keyword
        {
            get { return _keyword; }
            set { _keyword = value; }
        }

        public FindMethod FindMethod
        {
            get { return _findMethod; }
            set { _findMethod = value; }
        }

        public Boolean HasValue
        {
            get { return !String.IsNullOrEmpty(_keyword); }
        }

        public override string ToString()
        {
            return Keyword;
        }
    }

    //public struct KeywordSearchResult
    //{
    //    private FilePosition _position;
    //    private PropertyCollection _properties;


    //    public KeywordSearchResult(FilePosition position)
    //    {
    //        _position = position;
    //        _properties = new PropertyCollection();
    //    }


    //    public FilePosition Position
    //    {
    //        get { return _position; }
    //    }

    //    public PropertyCollection Properties
    //    {
    //        get { return _properties; }
    //    }

    //    public Boolean Found
    //    {
    //        get { return _position.IsValidPosition; }
    //    }
    //}
}
