using System;
using System.Collections.Generic;
using System.Text;

namespace LineCounter
{
    public struct SearchPatterns
    {
        private SearchFilterType _fileSearchFilterType;
        private SearchFilterType _folderSearchFilterType;
        private SearchPatternCollection _fileSearchPatterns;
        private SearchPatternCollection _folderSearchPatterns;


        public SearchPatterns(SearchFilterType fileSearchFilterType,
            SearchPatternCollection fileSearchPatterns,
            SearchFilterType folderSearchFilterType,
            SearchPatternCollection folderSearchPatterns)
        {
            _fileSearchFilterType = fileSearchFilterType;
            _fileSearchPatterns = fileSearchPatterns;
            _folderSearchFilterType = folderSearchFilterType;
            _folderSearchPatterns = folderSearchPatterns;
        }


        public SearchFilterType FileSearchFilterType
        {
            get { return _fileSearchFilterType; }
            set { _fileSearchFilterType = value; }
        }

        public SearchFilterType FolderSearchType
        {
            get { return _folderSearchFilterType; }
            set { _folderSearchFilterType = value; }
        }

        public SearchPatternCollection FileSearchPatterns
        {
            get { return _fileSearchPatterns; }
        }

        public SearchPatternCollection FolderSearchPatterns
        {
            get { return _folderSearchPatterns; }
        }

    }
}
