using System;
using System.Collections.Generic;
using System.Text;

namespace LineCounter
{
    public static class StringHelper
    {
        public static String MaskNullString(String value)
        {
            String result = String.Empty;

            if (value != null)
            {
                result = value;
            }

            return result;
        }

        public static Boolean IsNullOrEmpty(String value)
        {
            return MaskNullString(value).Length == 0;
        }


        public static int GetOccoursTime(Char c, String stringToCheck, int startIndex)
        {
            return GetOccoursTime(c, stringToCheck, startIndex, stringToCheck.Length);
        }

        public static int GetOccoursTime(Char c, String stringToCheck)
        {
            return GetOccoursTime(c, stringToCheck, 0, stringToCheck.Length);
        }

        public static int GetOccoursTime(Char c, String stringToCheck, int startIndex, int count)
        {
            int result = 0;
            int currentIndex = startIndex;

            currentIndex = stringToCheck.IndexOf(c, currentIndex, count - currentIndex) + 1;

            while (currentIndex >= 0)
            {
                result++;

                int foundIndex = 0;

                if (currentIndex < stringToCheck.Length)
                {
                    foundIndex = stringToCheck.IndexOf(c, currentIndex, count - currentIndex);
                }
                else
                {
                    break;
                }

                if (foundIndex < 0)
                {
                    currentIndex = -1;
                }
                else
                {
                    currentIndex = foundIndex + 1;
                }
            }

            return result;
        }

        public static int GetOccoursTime(String str, String stringToCheck, int startIndex)
        {
            return GetOccoursTime(str, stringToCheck, startIndex, stringToCheck.Length);
        }

        public static int GetOccoursTime(String str, String stringToCheck)
        {
            return GetOccoursTime(str, stringToCheck, 0, stringToCheck.Length);
        }

        public static int GetOccoursTime(String str, String stringToCheck, int startIndex, int count)
        {
            int result = 0;
            int currentIndex = startIndex;

            currentIndex = stringToCheck.IndexOf(str, currentIndex, count - currentIndex) + 1;

            while (currentIndex >= 0)
            {
                result++;

                int foundIndex = 0;

                if (currentIndex < stringToCheck.Length && currentIndex + str.Length < stringToCheck.Length)
                {
                    foundIndex = stringToCheck.IndexOf(str, currentIndex, count - currentIndex);
                }
                else
                {
                    break;
                }

                if (foundIndex < 0)
                {
                    currentIndex = -1;
                }
                else
                {
                    currentIndex = foundIndex + str.Length;
                }
            }

            return result;
        }


        public static FilePosition SearchKeywordIndex(String str, SearchKeyword keyword)
        {
            return SearchKeywordIndex(str, keyword, 0, str.Length);
        }

        public static FilePosition SearchKeywordIndex(String str, SearchKeyword keyword, int startIndex, int count)
        {
            switch (keyword.FindMethod)
            {
                case FindMethod.Normal:
                    {
                        Int32 index = str.IndexOf(keyword.Keyword, startIndex, count);

                        if (index >= 0)
                        {
                            return new FilePosition(index, keyword.Keyword.Length);
                        }

                        break;
                    }
                case FindMethod.RegularExpression:
                    {
                        System.Text.RegularExpressions.Match match = MatchString(str, keyword.Keyword, startIndex, count);

                        if (match.Success)
                        {
                            return new FilePosition(match.Index, match.Length);
                        }

                        break;
                    }
            }

            return new FilePosition(-1, 0);
        }

        public static FilePosition SearchKeywordIndex(String str, SearchKeyword keyword, int startIndex)
        {
            return SearchKeywordIndex(str, keyword, startIndex, keyword.Keyword.Length - startIndex - 1);
        }

        public static System.Text.RegularExpressions.Match MatchString(String str, String keyword, int startIndex, int count)
        {
            System.Text.RegularExpressions.Regex regex = new System.Text.RegularExpressions.Regex(keyword);
            System.Text.RegularExpressions.Match match = regex.Match(str, startIndex, count);

            return match;
        }
    }
}
